## pandoc 2.17.1.1

=== Makefile ===
version?=$(shell grep '^[Vv]ersion:' pandoc.cabal | awk '{print $$2;}')
pandoc=$(shell find dist -name pandoc -type f -exec ls -t {} \; | head -1)
SOURCEFILES?=$(shell git ls-tree -r master --name-only | grep "\.hs$$")
BRANCH?=master
ARCH=$(shell uname -m)
DOCKERIMAGE=registry.gitlab.b-data.ch/ghc/ghc4pandoc:9.0.2
COMMIT=$(shell git rev-parse --short HEAD)
TIMESTAMP=$(shell date "+%Y%m%d_%H%M")
LATESTBENCH=$(word 1,$(shell ls -t bench_*.csv 2>/dev/null))
BASELINE?=$(LATESTBENCH)
ifeq ($(BASELINE),)
BASELINECMD=
else
BASELINECMD=--baseline $(BASELINE)
endif
GHCOPTS=-fdiagnostics-color=always -j4 +RTS -A8m -RTS
WEBSITE=../../web/pandoc.org
REVISION?=1
# For gauge:
# BENCHARGS?=--small --ci=0.90 --match=pattern $(PATTERN)
# For tasty-bench:
BENCHARGS?=--csv bench_$(TIMESTAMP).csv $(BASELINECMD) --timeout=6 +RTS -T --nonmoving-gc -RTS $(if $(PATTERN),--pattern "$(PATTERN)",)

# Note:  to accept current results of golden tests,
# make test TESTARGS='--accept'
quick: ## build & test with stack, no optimizations
	stack install --ghc-options='$(GHCOPTS)' --system-ghc --flag 'pandoc:embed_data_files' --fast --test --test-arguments='-j4 --hide-successes --ansi-tricks=false $(TESTARGS)'

quick-cabal: ## build & test with stack, no optimizations
	cabal v2-build -j8 --ghc-options '$(GHCOPTS)' --disable-optimization --enable-tests
	cabal v2-test --disable-optimization --test-options="--hide-successes --ansi-tricks=false $(TESTARGS)"
	echo "Path to built executable:" && cabal exec -- sh -c 'command -v pandoc' | sed -e 's!x/pandoc/build!x/pandoc/noopt/build!'

full: ## build with stack, including benchmarks, trypandoc
	stack install --flag 'pandoc:embed_data_files' --flag 'pandoc:trypandoc' --bench --no-run-benchmarks --test --test-arguments='-j4 --hide-successes--ansi-tricks-false' --ghc-options '-Wall -Werror -fno-warn-unused-do-bind -O0 $(GHCOPTS)'

ghci: ## start ghci session
	stack ghci --flag 'pandoc:embed_data_files'

haddock: ## build haddocks
	stack haddock

check: check-cabal checkdocs ## prerelease checks
	cabal check # check cabal file
	cabal outdated # check cabal dependencies
	stack-lint-extra-deps # check that stack.yaml dependencies are up to date
	! grep 'git:' stack.yaml # use only released versions
	! grep 'git:' cabal.project # use only released versions

check-cabal: git-files.txt sdist-files.txt
	@echo "Checking to see if all committed test/data files are in sdist."
	diff -u $^

checkdocs:
	@echo "Checking for tabs in manual."
	! grep -q -n -e "\t" MANUAL.txt changelog.md

ghcid: ## run ghcid/stack
	ghcid -c "stack repl --flag 'pandoc:embed_data_files'"

ghcid-test: ## run ghcid/stack with tests
	ghcid -c "stack repl --ghc-options=-XNoImplicitPrelude --flag 'pandoc:embed_data_files' --ghci-options=-fobject-code pandoc:lib pandoc:test-pandoc"

bench: ## build and run benchmarks
	stack bench \
	  --ghc-options '$(GHCOPTS)' \
	  --benchmark-arguments='$(BENCHARGS)' 2>&1 | \
	  tee "bench_latest.txt"

reformat: ## reformat with stylish-haskell
	for f in $(SOURCEFILES); do echo $$f; stylish-haskell -i $$f ; done

lint: hlint fix_spacing ## run linters

hlint: ## run hlint
	for f in $(SOURCEFILES); do echo $$f; hlint --verbose --refactor --refactor-options='-s -o -' $$f; done

fix_spacing: ## Fix trailing newlines and spaces
	for f in $(SOURCEFILES); do printf '%s\n' "`cat $$f`" | sed -e 's/  *$$//' > $$f.tmp; mv $$f.tmp $$f; done

changes_github: ## copy this release's changes in gfm
	pandoc --filter tools/extract-changes.hs changelog.md -t gfm --wrap=none --template tools/changes_template.html | sed -e 's/\\#/#/g' | pbcopy


debpkg: ## create linux package
	docker run -v `pwd`:/mnt \
                   -v `pwd`/linux/artifacts:/artifacts \
		   --user $(id -u):$(id -g) \
		   -e REVISION=$(REVISION) \
		   -w /mnt \
		   --memory=0 \
		   --rm \
		   $(DOCKERIMAGE) \
		   bash \
		   /mnt/linux/make_artifacts.sh 2>&1 > docker.log

man/pandoc.1: MANUAL.txt man/pandoc.1.before man/pandoc.1.after
	pandoc $< -f markdown -t man -s \
		--lua-filter man/manfilter.lua \
		--include-before-body man/pandoc.1.before \
		--include-after-body man/pandoc.1.after \
		--metadata author="" \
		--variable footer="pandoc $(version)" \
		-o $@

README.md: README.template MANUAL.txt tools/update-readme.lua
	pandoc --lua-filter tools/update-readme.lua \
	      --reference-location=section -t gfm $< -o $@

download_stats: ## print download stats from GitHub releases
	curl https://api.github.com/repos/jgm/pandoc/releases | \
		jq -r '.[] | .assets | .[] | "\(.download_count)\t\(.name)"'

pandoc-templates: ## update pandoc-templates repo
	rm ../pandoc-templates/default.* ; \
	cp data/templates/* ../pandoc-templates/ ; \
	pushd ../pandoc-templates/ && \
	git add * && \
	git commit -m "Updated templates for pandoc $(version)" && \
	popd

trypandoc: ## build trypandoc on server
	ssh -t macfarlane 'cd src/pandoc && git pull && cabal update && cabal install -ftrypandoc -fembed_data_files --install-method=copy --overwrite-policy=always && cd trypandoc && sudo make install'

update-website: ## update website and upload
	make -C $(WEBSITE) update
	make -C $(WEBSITE)
	make -C $(WEBSITE) upload

clean: ## clean up
	stack clean

sdist-files.txt: .FORCE
	cabal sdist --list-only | sed 's/\.\///' | grep '^\(test\|data\)\/' | sort > $@

git-files.txt: .FORCE
	git ls-tree -r --name-only HEAD | grep '^\(test\|data\)\/' | sort > $@

.PHONY: help
help: ## Display this help
	@grep -E '^[ a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "%-30s %s\n", $$1, $$2}'

.PHONY: .FORCE deps quick haddock install clean test bench changes_github download_stats reformat lint weigh pandoc-templates trypandoc update-website debpkg checkdocs ghcid ghci fix_spacing hlint check check-cabal check

=== macos/Makefile ===
VERSION=$(shell cat version.txt)
BASE=pandoc-$(VERSION)
DEST=pandoc/usr/local
ALL=$(BASE)-macOS.pkg $(BASE)-macOS.zip

all: $(ALL) notarize

signed.txt: $(DEST)
	chmod +x $(DEST)/bin/pandoc
	codesign --force --options runtime -s "5U2WKE6DES" $(DEST)/bin/pandoc
	echo "SIGNED" > signed.txt

pandoc.pkg: signed.txt
	pkgbuild --root pandoc --identifier net.johnmacfarlane.pandoc --version $(VERSION) --ownership recommended $@

$(BASE)-macOS.pkg: pandoc.pkg
	productbuild --distribution distribution.xml --resources Resources --package-path $< --version $(VERSION) --sign 'Developer ID Installer: John Macfarlane' $@

$(BASE)-macOS.zip: signed.txt
	ln -s $(DEST) $(BASE)
	zip -r $@ $(BASE)

gon.hcl: version.txt
	echo "notarize {\n  path = \"$(BASE)-macOS.pkg\"\n  bundle_id = \"org.pandoc.pandoc\"\n  staple = true\n}\napple_id {\n  username = \"jgm@berkeley.edu\"\n  password = \"@env:AC_PASSWORD\"\n}" > $@

notarize: gon.hcl $(BASE)-macOS.pkg
	gon -log-level=warn ./gon.hcl

clean:
	rm signed.txt $(BASE) pandoc.pkg gon.hcl

distclean: clean
	rm $(ALL)

.PHONY: all clean distclean

=== trypandoc/Makefile ===
CGIBIN=/home/website/cgi-bin
TRYPANDOC=/home/website/pandoc.org/try/
CGI=${CGIBIN}/trypandoc
BIN=/home/jgm/.cabal/bin/trypandoc

install: ${CGI} ${TRYPANDOC}/index.html

${TRYPANDOC}/%: %
	cp $< $@ && chown website:www-data $@ && chmod a+r $@

${CGI}: ${BIN}
	cp $< $@ && chown website:www-data $@ && chmod a+rx $@

.PHONY: install

=== windows/Makefile ===
UNSIGNED=$(wildcard pandoc-*-UNSIGNED.msi)
SIGNED=$(patsubst %-UNSIGNED.msi, %.msi, $(UNSIGNED))

all: $(SIGNED)

.PHONY: all

pandoc-%.msi: pandoc-%-UNSIGNED.msi
	osslsigncode sign -pkcs12 $$HOME/Private/SectigoCodeSigning.exp2023.p12 -in $< -i https://johnmacfarlane.net/ -t http://timestamp.comodoca.com/ -out $@ -askpass && rm $<

=== debian/changelog ===
pandoc (2.17.1.1-2~deb12u1) bookworm; urgency=high

  * Non-maintainer upload.
  * Rebuild for bookworm.
  * Add d/salsa-ci.yml for Salsa CI.

 -- Guilhem Moulin <guilhem@debian.org>  Tue, 25 Jul 2023 23:01:50 +0200

pandoc (2.17.1.1-2) unstable; urgency=high

  * add patches cherry-picked upstream
    to fix arbitrary file write vulnerability;
    closes: bug#1041976, thanks to Guilhem Moulin;
    CVE-2023-35936 CVE-2023-35936

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 25 Jul 2023 18:43:57 +0200

pandoc (2.17.1.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Workaround i386 FTBFS with -O0. (Closes: #1023149)

 -- Adrian Bunk <bunk@debian.org>  Sat, 19 Nov 2022 15:13:51 +0200

pandoc (2.17.1.1-1) unstable; urgency=medium

  [ upstream ]
  * new release(s);
    closes: bug#979124, thanks to Kenshi Muto and Yukiharu YABUKI;
    contains many bugfixes and feature additions, including...:
    + DocBook reader: ensure that first and last names are separated;
      closes: bug#963128, thanks to Vincent Lefevre
    + DocBook reader: parse releaseinfo as metadata;
      closes: bug#963129, thanks to Vincent Lefevre
    + update template for reveal.js 4.0.0;
      closes: bug#969475, thanks to Thomas Clavier

  [ Jonas Smedegaard ]
  * drop patches cherry-picked upstream now applied
  * add patches cherry-picked upstream to use newer skylighting
  * update/unfuzz patches
  * add GHC (build-)dependencies for
    citeproc commonmark commonmark-extensions commonmark-pandoc
    file-embed hslua-aeson hslua-marshalling hslua-module-path
    hslua-module-version lpeg pandoc-lua-marshal pretty-show
    unicode-collation xml-conduit yaml;
    bump GHC bounds for
    haddock-library hslua hslua-module-system hslua-module-text
    ipynb jira-wiki-markup pandoc-types
    skylighting skylighting-core tasty-lua;
    tighten GHC bounds for texmath;
    tighten lower GHC bounds for doclayout doctemplates;
    relax upper GHC bounds for aeson attoparsec base64-bytestring
    blaze-markup network-uri random tasty unicode-transforms;
    drop unneeded lower GHC bounds for
    aeson-pretty blaze-html blaze-markup case-insensitive
    exceptions http-client http-client-tls network tagsoup
    tasty tasty-golden;
    drop GHC (build-)dependencies on
    bitarray cmark-gfm executable-path hsyaml http
    quickcheck2 unordered-containers
  * update copyright info: update coverage
  * update TODOs
  * update long descriptions,
    based on upstream Cabal file project description

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 13 Aug 2022 16:45:31 +0200

pandoc (2.10-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update TODOs: list packages needed for which upgrades
  * unfuzz patches
  * add GHC (build-)dependencies for connection;
    bump GHC bounds for hslua pandoc-types;
    tighten lower GHC bounds for doctemplates
    hslua-module-text skylighting skylighting-core texmath;
    relax upper GHC bounds for aeson haddock-library
    base64-bytestring http-client quickcheck2 tasty;
    drop GHC (build-)dependencies for vector
  * update copyright info: update coverage
  * declare compliance with Debian Policy 4.6.1
  * update git-buildpackage config:
    + use DEP-14 git branches
    + enable automatic DEP-14 branch name handling
    + stop filter dist/*
    + add usage config
  * modernize source helper copyright-check
  * enable tests before loading haskell snippets,
    apparently needed by recent dh-haskell
  * extend patch 2001 to cover html-related tests
  * add patches cherry-picked upstream
    to modernize jira-wiki-markup

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 01 Jun 2022 08:03:18 +0200

=== debian/control ===
Source: pandoc
Section: text
Priority: optional
Maintainer: Debian Haskell Group <debian-haskell@lists.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>
 , Kiwamu Okabe <kiwamu@debian.or.jp>
 , Clint Adams <clint@debian.org>
Build-Depends: cdbs,
 debhelper,
 dh-buildinfo,
 ghc,
 ghc-prof,
 alex,
 happy,
 libghc-aeson-dev (<< 2.1),
 libghc-aeson-prof,
 libghc-aeson-pretty-dev (<< 0.9),
 libghc-aeson-pretty-prof,
 libghc-attoparsec-dev (<< 0.15),
 libghc-attoparsec-prof,
 libghc-base64-bytestring-dev (<< 1.3),
 libghc-base64-bytestring-prof,
 libghc-blaze-html-dev (<< 0.10),
 libghc-blaze-html-prof,
 libghc-blaze-markup-dev (<< 0.9),
 libghc-blaze-markup-prof,
 libghc-case-insensitive-dev (<< 1.3),
 libghc-case-insensitive-prof,
 libghc-citeproc-dev (<< 0.7),
 libghc-citeproc-prof,
 libghc-commonmark-dev (<< 0.3),
 libghc-commonmark-prof,
 libghc-commonmark-extensions-dev (<< 0.3),
 libghc-commonmark-extensions-prof,
 libghc-commonmark-pandoc-dev (<< 0.3),
 libghc-commonmark-pandoc-prof,
 libghc-connection-dev (>= 0.3.1),
 libghc-connection-prof,
 libghc-data-default-dev (<< 0.8),
 libghc-data-default-prof,
 libghc-doclayout-dev (>= 0.3.1.1),
 libghc-doclayout-dev (<< 0.4),
 libghc-doclayout-prof,
 libghc-doctemplates-dev (>= 0.10),
 libghc-doctemplates-dev (<< 0.11),
 libghc-doctemplates-prof,
 libghc-emojis-dev (<< 0.2),
 libghc-emojis-prof,
 libghc-exceptions-dev (<< 0.11),
 libghc-exceptions-prof,
 libghc-file-embed-dev (<< 0.1),
 libghc-file-embed-prof,
 libghc-glob-dev (<< 0.11),
 libghc-glob-prof,
 libghc-haddock-library-dev (>= 1.10),
 libghc-haddock-library-dev (<< 1.11),
 libghc-haddock-library-prof,
 libghc-hslua-dev (>= 2.1),
 libghc-hslua-dev (<< 2.2),
 libghc-hslua-prof,
 libghc-hslua-aeson-dev (>= 2.1),
 libghc-hslua-aeson-dev (<< 2.2),
 libghc-hslua-aeson-prof,
 libghc-hslua-marshalling-dev (>= 2.1),
 libghc-hslua-marshalling-dev (<< 2.2),
 libghc-hslua-marshalling-prof,
 libghc-hslua-module-path-dev (<< 1.1),
 libghc-hslua-module-path-prof,
 libghc-hslua-module-system-dev (>= 1),
 libghc-hslua-module-system-dev (<< 1.1),
 libghc-hslua-module-system-prof,
 libghc-hslua-module-text-dev (>= 1),
 libghc-hslua-module-text-dev (<< 1.1),
 libghc-hslua-module-text-prof,
 libghc-hslua-module-version-dev (<< 1.1),
 libghc-hslua-module-version-prof,
 libghc-http-client-dev (<< 0.8),
 libghc-http-client-prof,
 libghc-http-client-tls-dev (<< 0.4),
 libghc-http-client-tls-prof,
 libghc-http-types-dev (<< 0.13),
 libghc-http-types-prof,
 libghc-ipynb-dev (>= 0.2),
 libghc-ipynb-dev (<< 0.3),
 libghc-ipynb-prof,
 libghc-jira-wiki-markup-dev (>= 1.4),
 libghc-jira-wiki-markup-dev (<< 1.5),
 libghc-jira-wiki-markup-prof,
 libghc-juicypixels-dev (<< 3.4),
 libghc-juicypixels-prof,
 libghc-lpeg-dev (<< 1.1),
 libghc-lpeg-prof,
 libghc-network-dev,
 libghc-network-prof,
 libghc-network-uri-dev (<< 2.8),
 libghc-network-uri-prof,
 libghc-pandoc-lua-marshal-dev (<< 0.2),
 libghc-pandoc-lua-marshal-prof,
 libghc-pandoc-types-dev (>= 1.22.1),
 libghc-pandoc-types-dev (<< 1.23),
 libghc-pandoc-types-prof,
 libghc-pretty-show-dev (>= 1.10),
 libghc-pretty-show-dev (<< 1.11),
 libghc-pretty-show-prof,
 libghc-random-dev (<< 1.3),
 libghc-random-prof,
 libghc-safe-dev (<< 0.4),
 libghc-safe-prof,
 libghc-scientific-dev (<< 0.4),
 libghc-scientific-prof,
 libghc-sha-dev (<< 1.7),
 libghc-sha-prof,
 libghc-skylighting-dev (>= 0.12.3.1),
 libghc-skylighting-dev (<< 0.13),
 libghc-skylighting-prof,
 libghc-skylighting-core-dev (>= 0.12.3.1),
 libghc-skylighting-core-dev (<< 0.13),
 libghc-skylighting-core-prof,
 libghc-split-dev (<< 0.3),
 libghc-split-prof,
 libghc-syb-dev (<< 0.8),
 libghc-syb-prof,
 libghc-tagsoup-dev (<< 0.15),
 libghc-tagsoup-prof,
 libghc-temporary-dev (<< 1.4),
 libghc-temporary-prof,
 libghc-texmath-dev (>= 0.12.4),
 libghc-texmath-dev (<< 0.12.5),
 libghc-texmath-prof,
 libghc-text-conversions-dev (<< 0.4),
 libghc-text-conversions-prof,
 libghc-unicode-collation-dev (<< 0.2),
 libghc-unicode-collation-prof,
 libghc-unicode-transforms-dev (<< 0.5),
 libghc-unicode-transforms-prof,
 libghc-xml-dev (<< 1.4),
 libghc-xml-prof,
 libghc-xml-conduit-dev (>= 1.9.1.1),
 libghc-xml-conduit-dev (<< 1.10),
 libghc-xml-conduit-prof,
 libghc-yaml-dev (>= 0.11),
 libghc-yaml-dev (<< 0.12),
 libghc-yaml-prof,
 libghc-zip-archive-dev (<< 0.5),
 libghc-zip-archive-prof,
 libghc-zlib-dev (<< 0.7),
 libghc-zlib-prof,
 libghc-diff-dev (<< 0.5),
 libghc-tasty-dev (<< 1.5),
 libghc-tasty-golden-dev (<< 2.4),
 libghc-tasty-hunit-dev (<< 0.11),
 libghc-tasty-lua-dev (>= 1),
 libghc-tasty-lua-dev (<< 1.1),
 libghc-tasty-quickcheck-dev (<< 0.11),
 haskell-devscripts,
 bash-completion
Build-Depends-Indep: ghc-doc,
 libghc-aeson-doc,
 libghc-aeson-pretty-doc,
 libghc-ansi-terminal-doc,
 libghc-asn1-encoding-doc,
 libghc-asn1-parse-doc,
 libghc-asn1-types-doc,
 libghc-async-doc,
 libghc-attoparsec-doc,
 libghc-base-compat-batteries-doc,
 libghc-base-compat-doc,
 libghc-base-orphans-doc,
 libghc-base16-bytestring-doc,
 libghc-base64-bytestring-doc,
 libghc-basement-doc,
 libghc-blaze-builder-doc,
 libghc-blaze-html-doc,
 libghc-blaze-markup-doc,
 libghc-case-insensitive-doc,
 libghc-cereal-doc,
 libghc-citeproc-doc,
 libghc-commonmark-doc,
 libghc-commonmark-extensions-doc,
 libghc-commonmark-pandoc-doc,
 libghc-colour-doc,
 libghc-connection-doc,
 libghc-cookie-doc,
 libghc-cryptonite-doc,
 libghc-data-default-class-doc,
 libghc-data-default-doc,
 libghc-data-default-instances-containers-doc,
 libghc-data-default-instances-dlist-doc,
 libghc-data-default-instances-old-locale-doc,
 libghc-digest-doc,
 libghc-dlist-doc,
 libghc-doclayout-doc,
 libghc-doctemplates-doc,
 libghc-emojis-doc,
 libghc-errors-doc,
 libghc-exceptions-doc,
 libghc-file-embed-doc,
 libghc-glob-doc,
 libghc-haddock-library-doc,
 libghc-hashable-doc,
 libghc-hourglass-doc,
 libghc-hslua-doc,
 libghc-hslua-aeson-doc,
 libghc-hslua-marshalling-doc,
 libghc-hslua-module-path-doc,
 libghc-hslua-module-system-doc,
 libghc-hslua-module-text-doc,
 libghc-hslua-module-version-doc,
 libghc-hsyaml-doc,
 libghc-http-doc,
 libghc-http-client-doc,
 libghc-http-client-tls-doc,
 libghc-http-types-doc,
 libghc-hxt-charproperties-doc,
 libghc-hxt-doc,
 libghc-hxt-regex-xmlschema-doc,
 libghc-hxt-unicode-doc,
 libghc-integer-logarithms-doc,
 libghc-ipynb-doc,
 libghc-jira-wiki-markup-doc,
 libghc-juicypixels-doc,
 libghc-lpeg-doc,
 libghc-memory-doc,
 libghc-mime-types-doc,
 libghc-network-doc,
 libghc-network-uri-doc,
 libghc-old-locale-doc,
 libghc-pandoc-lua-marshal-doc,
 libghc-pandoc-types-doc,
 libghc-pem-doc,
 libghc-primitive-doc,
 libghc-quickcheck2-doc,
 libghc-random-doc,
 libghc-regex-base-doc,
 libghc-regex-pcre-doc,
 libghc-safe-doc,
 libghc-scientific-doc,
 libghc-sha-doc,
 libghc-skylighting-core-doc,
 libghc-skylighting-doc,
 libghc-socks-doc,
 libghc-split-doc,
 libghc-splitmix-doc,
 libghc-streaming-commons-doc,
 libghc-syb-doc,
 libghc-tagged-doc,
 libghc-tagsoup-doc,
 libghc-temporary-doc,
 libghc-texmath-doc,
 libghc-text-conversions-doc,
 libghc-th-abstraction-doc,
 libghc-time-compat-doc,
 libghc-tls-doc,
 libghc-transformers-compat-doc,
 libghc-unicode-collation-doc,
 libghc-unicode-transforms-doc,
 libghc-unordered-containers-doc,
 libghc-utf8-string-doc,
 libghc-uuid-types-doc,
 libghc-x509-doc,
 libghc-x509-store-doc,
 libghc-x509-system-doc,
 libghc-x509-validation-doc,
 libghc-xml-doc,
 libghc-xml-conduit-doc,
 libghc-yaml-doc,
 libghc-zip-archive-doc,
 libghc-zlib-doc,
Standards-Version: 4.6.1
Homepage: https://pandoc.org/
Vcs-Git: https://salsa.debian.org/haskell-team/pandoc.git
Vcs-Browser: https://salsa.debian.org/haskell-team/pandoc
Rules-Requires-Root: no

Package: pandoc
Architecture: any
Depends: ${cdbs:Depends}
 , ${misc:Depends}
 , ${shlibs:Depends}
 , pandoc-data (>= ${source:Version})
 , pandoc-data (<< ${source:Version}.~)
Recommends: ${cdbs:Recommends}
Suggests: ${cdbs:Suggests}
Provides:
 pandoc-abi (= ${pandoc:Abi}),
Multi-Arch: foreign
Description: general markup converter
 Pandoc is a Haskell library for converting
 from one markup format to another,
 and a command-line tool that uses this library.
 The formats it can handle include
  * light markup formats
    (many variants of Markdown, reStructuredText, AsciiDoc,
     Org-mode, Muse, Textile, txt2tags)
  * HTML formats (HTML 4 and 5)
  * Ebook formats (EPUB v2 and v3, FB2)
  * Documentation formats (GNU TexInfo, Haddock)
  * Roff formats (man, ms)
  * TeX formats (LaTeX, ConTeXt)
  * XML formats
    (DocBook 4 and 5, JATS, TEI Simple, OpenDocument)
  * Outline formats (OPML)
  * Bibliography formats (BibTeX, BibLaTeX, CSL JSON, CSL YAML)
  * Word processor formats (Docx, RTF, ODT)
  * Interactive notebook formats (Jupyter notebook ipynb)
  * Page layout formats (InDesign ICML)
  * Wiki markup formats
    (MediaWiki, DokuWiki, TikiWiki, TWiki,
     Vimwiki, XWiki, ZimWiki, Jira wiki, Creole)
  * Slide show formats
    (LaTeX Beamer, PowerPoint, Slidy,
     reveal.js, Slideous, S5, DZSlides)
  * Data formats (CSV tables)
  * PDF (via external programs such as pdflatex or wkhtmltopdf)
 .
 Pandoc can convert mathematical content in documents
 between TeX, MathML, Word equations, roff eqn, and plain text.
 It includes a powerful system
 for automatic citations and bibliographies,
 and it can be customized extensively using templates, filters,
 and custom readers and writers written in Lua.
 .
 This package contains the pandoc tool.
 .
 Some uses of Pandoc require additional packages:
  * SVG content in PDF output requires librsvg2-bin.
  * YAML metadata in TeX-related output requires texlive-latex-extra.
  * *.hs filters not set executable requires ghc.
  * *.js filters not set executable requires nodejs.
  * *.php filters not set executable requires php.
  * *.pl filters not set executable requires perl.
  * *.py filters not set executable requires python.
  * *.rb filters not set executable requires ruby.
  * *.r filters not set executable requires r-base-core.
  * LaTeX output, and PDF output via PDFLaTeX,
    require texlive-latex-recommended.
  * XeLaTeX output, and PDF output via XeLaTeX, require texlive-xetex.
  * LuaTeX output, and PDF output via LuaTeX, require texlive-luatex.
  * ConTeXt output, and PDF output via ConTeXt, require context.
  * PDF output via wkhtmltopdf requires wkhtmltopdf.
  * Roff man and roff ms output, and PDF output via roff ms,
    require groff.
  * MathJax-rendered equations require libjs-mathjax.
  * KaTeX-rendered equations require node-katex.
  * option --csl may use styles in citation-style-language-styles.

Package: pandoc-data
Architecture: all
Depends: ${cdbs:Depends}
 , ${misc:Depends}
Recommends: ${cdbs:Recommends}
Suggests: ${cdbs:Suggests}
Multi-Arch: foreign
Description: general markup converter - data files
 Pandoc is a Haskell library for converting
 from one markup format to another,
 and a command-line tool that uses this library.
 The formats it can handle include
  * light markup formats
    (many variants of Markdown, reStructuredText, AsciiDoc,
     Org-mode, Muse, Textile, txt2tags)
  * HTML formats (HTML 4 and 5)
  * Ebook formats (EPUB v2 and v3, FB2)
  * Documentation formats (GNU TexInfo, Haddock)
  * Roff formats (man, ms)
  * TeX formats (LaTeX, ConTeXt)
  * XML formats
    (DocBook 4 and 5, JATS, TEI Simple, OpenDocument)
  * Outline formats (OPML)
  * Bibliography formats (BibTeX, BibLaTeX, CSL JSON, CSL YAML)
  * Word processor formats (Docx, RTF, ODT)
  * Interactive notebook formats (Jupyter notebook ipynb)
  * Page layout formats (InDesign ICML)
  * Wiki markup formats
    (MediaWiki, DokuWiki, TikiWiki, TWiki,
     Vimwiki, XWiki, ZimWiki, Jira wiki, Creole)
  * Slide show formats
    (LaTeX Beamer, PowerPoint, Slidy,
     reveal.js, Slideous, S5, DZSlides)
  * Data formats (CSV tables)
  * PDF (via external programs such as pdflatex or wkhtmltopdf)
 .
 Pandoc can convert mathematical content in documents
 between TeX, MathML, Word equations, roff eqn, and plain text.

=== debian/rules ===
#!/usr/bin/make -f

DEB_ENABLE_TESTS = yes

include /usr/share/cdbs/1/rules/debhelper.mk
-include /usr/share/cdbs/1/class/hlibrary.mk

pkg = $(DEB_SOURCE_PACKAGE)

ABI = $(shell dpkg-query --showformat='$${source:Version}' --show libghc-pandoc-types-dev)

# helper macros for GHC dependencies, e.g.: foo bar,dev,prof doc,>=,1.2,<<,1.3 baz
expand-or-strip-ghc-dep = $(foreach expandsuffix,$1,\
 $(comma) libghc-$3-$(expandsuffix) $(if $4,($4 $5))\
 $(if $6,\
  $(comma) libghc-$3-$(expandsuffix) ($6 $7)))\
 $(foreach stripsuffix,$2,\
  $(comma) libghc-$3-$(stripsuffix))
expand-ghc-deps = $(foreach dep,$(sort $3),$(call expand-or-strip-ghc-dep,\
 $1,\
 $2,$(strip \
 $(word 1,$(subst $(comma),$(space),$(dep)))),$(strip \
 $(word 2,$(subst $(comma),$(space),$(dep)))),$(strip \
 $(word 3,$(subst $(comma),$(space),$(dep)))),$(strip \
 $(word 4,$(subst $(comma),$(space),$(dep)))),$(strip \
 $(word 5,$(subst $(comma),$(space),$(dep))))))

# Haskell dependencies for any build from pandoc.cabal
ghc-deps += glob,<<,0.11
ghc-deps += juicypixels,<<,3.4
ghc-deps += sha,<<,1.7
ghc-deps += aeson,<<,2.1
ghc-deps += aeson-pretty,<<,0.9
ghc-deps += attoparsec,<<,0.15
ghc-deps += base64-bytestring,<<,1.3
ghc-deps += blaze-html,<<,0.10
ghc-deps += blaze-markup,<<,0.9
ghc-deps += case-insensitive,<<,1.3
ghc-deps += citeproc,<<,0.7
ghc-deps += commonmark,<<,0.3
ghc-deps += commonmark-extensions,<<,0.3
ghc-deps += commonmark-pandoc,<<,0.3
ghc-deps += connection,>=,0.3.1
ghc-deps += data-default,<<,0.8
ghc-deps += doclayout,>=,0.3.1.1,<<,0.4
ghc-deps += doctemplates,>=,0.10,<<,0.11
ghc-deps += emojis,<<,0.2
ghc-deps += exceptions,<<,0.11
ghc-deps += file-embed,<<,0.1
ghc-deps += haddock-library,>=,1.10,<<,1.11
ghc-deps += hslua,>=,2.1,<<,2.2
ghc-deps += hslua-aeson,>=,2.1,<<,2.2
ghc-deps += hslua-marshalling,>=,2.1,<<,2.2
ghc-deps += hslua-module-path,<<,1.1
ghc-deps += hslua-module-system,>=,1,<<,1.1
ghc-deps += hslua-module-text,>=,1,<<,1.1
ghc-deps += hslua-module-version,<<,1.1
ghc-deps += http-client,<<,0.8
ghc-deps += http-client-tls,<<,0.4
ghc-deps += http-types,<<,0.13
ghc-deps += ipynb,>=,0.2,<<,0.3
ghc-deps += jira-wiki-markup,>=,1.4,<<,1.5
ghc-deps += lpeg,<<,1.1
ghc-deps += network
ghc-deps += network-uri,<<,2.8
ghc-deps += pandoc-lua-marshal,<<,0.2
ghc-deps += pandoc-types,>=,1.22.1,<<,1.23
ghc-deps += pretty-show,>=,1.10,<<,1.11
ghc-deps += random,<<,1.3
ghc-deps += safe,<<,0.4
ghc-deps += scientific,<<,0.4
ghc-deps += skylighting,>=,0.12.3.1,<<,0.13
ghc-deps += skylighting-core,>=,0.12.3.1,<<,0.13
ghc-deps += split,<<,0.3
ghc-deps += syb,<<,0.8
ghc-deps += tagsoup,<<,0.15
ghc-deps += temporary,<<,1.4
ghc-deps += texmath,>=,0.12.4,<<,0.12.5
ghc-deps += text-conversions,<<,0.4
ghc-deps += unicode-collation,<<,0.2
ghc-deps += unicode-transforms,<<,0.5
ghc-deps += xml,<<,1.4
ghc-deps += xml-conduit,>=,1.9.1.1,<<,1.10
ghc-deps += yaml,>=,0.11,<<,0.12
ghc-deps += zip-archive,<<,0.5
ghc-deps += zlib,<<,0.7

# Haskell dependencies for testsuite from pandoc.cabal
ghc-deps-test += diff,<<,0.5
ghc-deps-test += tasty,<<,1.5
ghc-deps-test += tasty-golden,<<,2.4
ghc-deps-test += tasty-hunit,<<,0.11
ghc-deps-test += tasty-lua,>=,1,<<,1.1
ghc-deps-test += tasty-quickcheck,<<,0.11

# Haskell dependencies (maybe) needed for documentation
# TODO: actually use these (not maintain Build-depends-indep by hand)
ghc-deps-doc += ansi-terminal
ghc-deps-doc += asn1-encoding
ghc-deps-doc += asn1-parse
ghc-deps-doc += asn1-types
ghc-deps-doc += async
ghc-deps-doc += base16-bytestring
ghc-deps-doc += base-compat
ghc-deps-doc += base-compat-batteries
ghc-deps-doc += basement
ghc-deps-doc += base-orphans
ghc-deps-doc += blaze-builder
ghc-deps-doc += cereal
ghc-deps-doc += colour
ghc-deps-doc += connection
ghc-deps-doc += cookie
ghc-deps-doc += cryptonite
ghc-deps-doc += data-default-class
ghc-deps-doc += data-default-instances-containers
ghc-deps-doc += data-default-instances-dlist
ghc-deps-doc += data-default-instances-old-locale
ghc-deps-doc += digest
ghc-deps-doc += dlist
ghc-deps-doc += errors
ghc-deps-doc += hashable
ghc-deps-doc += hourglass
ghc-deps-doc += hs-bibutils
ghc-deps-doc += hsyaml
ghc-deps-doc += hxt
ghc-deps-doc += hxt-charproperties
ghc-deps-doc += hxt-regex-xmlschema
ghc-deps-doc += hxt-unicode
ghc-deps-doc += integer-logarithms
ghc-deps-doc += memory
ghc-deps-doc += mime-types
ghc-deps-doc += old-locale
ghc-deps-doc += pcre-light
ghc-deps-doc += pem
ghc-deps-doc += primitive
ghc-deps-doc += quickcheck2
ghc-deps-doc += regex-base
ghc-deps-doc += regex-pcre
ghc-deps-doc += rts
ghc-deps-doc += socks
ghc-deps-doc += splitmix
ghc-deps-doc += streaming-commons
ghc-deps-doc += tagged
ghc-deps-doc += th-abstraction
ghc-deps-doc += time-compat
ghc-deps-doc += tls
ghc-deps-doc += transformers
ghc-deps-doc += transformers-compat
ghc-deps-doc += unicode-transforms
ghc-deps-doc += utf8-string
ghc-deps-doc += uuid-types
ghc-deps-doc += x509
ghc-deps-doc += x509-store
ghc-deps-doc += x509-system
ghc-deps-doc += x509-validation

# Needed by upstream build process
CDBS_BUILD_DEPENDS +=, ghc, ghc-prof, alex, happy
CDBS_BUILD_DEPENDS += $(call expand-ghc-deps,dev,prof,$(ghc-deps))
CDBS_BUILD_DEPENDS += $(call expand-ghc-deps,dev,,$(ghc-deps-test))
CDBS_BUILD_DEPENDS_INDEP +=, ghc-doc
CDBS_BUILD_DEPENDS_INDEP +=, $(call expand-ghc-deps,,doc,$(ghc-deps) $(ghc-deps-doc))

# Needed for our packaging
#  * recent haskell-devscripts needed for version-less datadir
CDBS_BUILD_DEPENDS +=, haskell-devscripts

# Needed (always/often/seldom) at runtime
#  texlive-* needed for PDF output
#  librsvg2-bin (rsvg-convert) needed for SVG in PDF output
#  groff needed for groff man and groff ms output
# TODO: suggest slide show Javascript libraries when in Debian
CDBS_SUGGESTS_$(pkg) = texlive-latex-recommended, texlive-xetex, texlive-luatex
CDBS_SUGGESTS_$(pkg) +=, pandoc-citeproc, texlive-latex-extra, context
CDBS_SUGGESTS_$(pkg) +=, wkhtmltopdf, librsvg2-bin, groff, ghc, nodejs
CDBS_SUGGESTS_$(pkg) +=, php, perl, python, ruby, r-base-core
CDBS_SUGGESTS_$(pkg) +=, libjs-mathjax, libjs-katex
CDBS_SUGGESTS_$(pkg) +=, citation-style-language-styles

# Fix exception thrown building documentation:
# haddock: internal error: <stdout>: commitBuffer: invalid argument (invalid character)
export LANG=C.UTF-8

# Use threaded RTS only when supported
DEB_SETUP_GHC_CONFIGURE_ARGS += $(if $(wildcard /usr/lib/ghc-$(GHC_VERSION)/libHSrts_thr.a),,--flags=-threaded)

# Disable timer to help build on slow arches like hppa
DEB_SETUP_GHC_CONFIGURE_ARGS += --ghc-options="+RTS -V0 -RTS"

# Reduce compile-time memory utilization on low-memory architectures
ifneq (,$(filter $(DEB_BUILD_ARCH),armel armhf hppa mips mipsel))
DEB_SETUP_GHC_CONFIGURE_ARGS += --ghc-options="-optc--param -optcggc-min-expand=10 -O0"
endif

ifneq (,$(filter $(DEB_HOST_ARCH_CPU), i386))
DEB_SETUP_GHC_CONFIGURE_ARGS += --ghc-options="-O0"
endif

DEB_SETUP_GHC_CONFIGURE_ARGS += $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),,-ftests)

DEB_INSTALL_DOCS_ALL += README.md

DEB_INSTALL_MANPAGES_$(pkg) = man/pandoc.1

CDBS_BUILD_DEPENDS +=, bash-completion
post-install/$(pkg)::
	debian/tmp-inst-*/usr/bin/pandoc --bash-completion \
		> debian/pandoc.bash-completion
binary-install/$(pkg)::
	dh_bash-completion
clean::
	rm -f debian/pandoc.bash-completion

DEB_DH_GENCONTROL_ARGS_$(pkg) = -- -V"pandoc:Abi=$(ABI)"

## pandoc 3.1.3+ds

=== debian/changelog ===
pandoc (3.1.3+ds-2) unstable; urgency=medium

  * tighten build-dependency on libghc-pandoc-dev
  * drop patches 2001_*, obsoleted by upstream changes;
    tighten GHC lower bounds for hslua-cli pandoc-lua-engine

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 07 Jan 2024 01:52:39 +0100

pandoc (3.1.3+ds-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * update patches
  * mention support for Typst format in long description
  * update TODOs

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 03 Jan 2024 20:32:48 +0100

pandoc (3.0.1+ds-3) unstable; urgency=medium

  * strip repackaging suffix from resolved dependency

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 11 Dec 2023 10:57:50 +0100

pandoc (3.0.1+ds-2) unstable; urgency=medium

  * stop prefix library version
  * avoid generating man page
    on architectures where the executable is built with Lua support;
    closes: bug#1057952, thanks to Sebastian Ramacher

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 10 Dec 2023 23:14:13 +0100

pandoc (3.0.1+ds-1) unstable; urgency=medium

  * re-release as version 3.0.1;
    this version technically does not exist upstream
    (only for the library part, not the command-line tool),
    but upstream has decided in future to use same version scheme.
  * update watch file: track git-tagged releases
  * add TODO notes about future releases

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 10 Dec 2023 22:29:24 +0100

pandoc (2.17.1.1+~git20230125+ds-1) unstable; urgency=medium

  [ upstream ]
  * new release(s);
    closes: bug#1053686,
    thanks to Adrian Bunk, Paul Gevers, Ilias Tsitsimpis,
    Scott Talbert and John MacFarlane

  [ Jonas Smedegaard ]
  * update watch file:
    + track Github source (not Hackage distribution)
    + mangle upstream version to prepend last upstream 2.x version
    + use repackaging suffix +ds
  * update copyright info:
    + list only Github source URI
    + repackage upstream source
      to exclude everything but pandoc-cli directory
    + update coverage
  * stop resolve build-dependencies in rules file
  * stop provide binary packages
    pandoc-data libghc-pandoc-dev libghc-pandoc-doc libghc-pandoc-prof;
    drop all previous patches, now obsolete;
    build-depend on GHC projects
    hslua-cli pandoc pandoc-lua-engine temporary
    (and only core projects besides those);
    closes: bug#1050012, thanks (again) to Bastian Germann;
    closes: bug#1057309,
    thanks to Hannes von Haugwitz and Scott Talbert
  * declare compliance with Debian Policy 4.6.2
  * add patch 2001 to accept older releases
    of GHC projects hslua-cli pandoc-lua-engine;
    relax related build-dependencies
  * populate source code at root during build,
    where haskell-devscripts can use it
  * mention support for bibliography format RIS and data format TSV
    in long description
  * prepend upstream library version to binary package version
    (see <https://github.com/jgm/pandoc/issues/9232>)
  * use forked Haskell build helper script to support DEB_CABAL_FILE
  * generate map page from source;
    build-depend on pandoc-data
  * adjust dependency on pandoc-data

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 09 Dec 2023 14:46:32 +0100

pandoc (2.17.1.1-3) unstable; urgency=medium

  * stop build-depend on libghc-regex-pcre-doc;
    closes: bug#1050012, thanks to Bastian Germann
  * update copyright info: update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 30 Aug 2023 11:20:29 +0200

=== debian/control ===
Source: pandoc
Section: text
Priority: optional
Maintainer: Debian Haskell Group <debian-haskell@lists.debian.org>
Uploaders:
 Jonas Smedegaard <dr@jones.dk>,
 Kiwamu Okabe <kiwamu@debian.or.jp>,
 Clint Adams <clint@debian.org>,
Build-Depends:
 alex,
 bash-completion,
 cdbs,
 debhelper,
 dh-buildinfo,
 ghc,
 ghc-prof,
 happy,
 haskell-devscripts,
 libghc-hslua-cli-dev (<< 1.5) [!ppc64 !ppc64el],
 libghc-hslua-cli-dev (>= 1.4.1) [!ppc64 !ppc64el],
 libghc-hslua-cli-prof [!ppc64 !ppc64el],
 libghc-pandoc-dev (>= 3.1.3),
 libghc-pandoc-lua-engine-dev (<< 0.3) [!ppc64 !ppc64el],
 libghc-pandoc-lua-engine-dev (>= 0.2) [!ppc64 !ppc64el],
 libghc-pandoc-lua-engine-prof [!ppc64 !ppc64el],
 libghc-pandoc-prof,
 libghc-temporary-dev (<< 1.4) [!ppc64 !ppc64el],
 libghc-temporary-prof [!ppc64 !ppc64el],
 pandoc-data,
Standards-Version: 4.6.2
Homepage: https://pandoc.org/
Vcs-Git: https://salsa.debian.org/haskell-team/pandoc.git
Vcs-Browser: https://salsa.debian.org/haskell-team/pandoc
Rules-Requires-Root: no

Package: pandoc
Architecture: any
Depends:
 pandoc-data (<< ${pandoc:Lib}.~),
 pandoc-data (>= ${pandoc:Lib}),
 ${cdbs:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ${cdbs:Recommends},
Suggests:
 ${cdbs:Suggests},
Provides:
 pandoc-abi (= ${pandoc:Abi}),
Multi-Arch: foreign
Description: general markup converter
 Pandoc is a Haskell library for converting
 from one markup format to another,
 and a command-line tool that uses this library.
 The formats it can handle include
  * light markup formats
    (many variants of Markdown, reStructuredText, AsciiDoc,
     Org-mode, Muse, Textile, txt2tags)
  * HTML formats (HTML 4 and 5)
  * Ebook formats (EPUB v2 and v3, FB2)
  * Documentation formats (GNU TexInfo, Haddock)
  * Roff formats (man, ms)
  * TeX formats (LaTeX, ConTeXt)
  * Typst
  * XML formats
    (DocBook 4 and 5, JATS, TEI Simple, OpenDocument)
  * Outline formats (OPML)
  * Bibliography formats (BibTeX, BibLaTeX, CSL JSON, CSL YAML, RIS)
  * Word processor formats (Docx, RTF, ODT)
  * Interactive notebook formats (Jupyter notebook ipynb)
  * Page layout formats (InDesign ICML)
  * Wiki markup formats
    (MediaWiki, DokuWiki, TikiWiki, TWiki,
     Vimwiki, XWiki, ZimWiki, Jira wiki, Creole)
  * Slide show formats
    (LaTeX Beamer, PowerPoint, Slidy,
     reveal.js, Slideous, S5, DZSlides)
  * Data formats (CSV and TSV tables)
  * PDF (via external programs such as pdflatex or wkhtmltopdf)
 .
 Pandoc can convert mathematical content in documents
 between TeX, MathML, Word equations, roff eqn, typst,
 and plain text.
 It includes a powerful system
 for automatic citations and bibliographies,
 and it can be customized extensively using templates, filters,
 and custom readers and writers written in Lua.
 .
 This package contains the pandoc tool.
 .
 Some uses of Pandoc require additional packages:
  * SVG content in PDF output requires librsvg2-bin.
  * YAML metadata in TeX-related output requires texlive-latex-extra.
  * *.hs filters not set executable requires ghc.
  * *.js filters not set executable requires nodejs.
  * *.php filters not set executable requires php.
  * *.pl filters not set executable requires perl.
  * *.py filters not set executable requires python.
  * *.rb filters not set executable requires ruby.
  * *.r filters not set executable requires r-base-core.
  * LaTeX output, and PDF output via PDFLaTeX,
    require texlive-latex-recommended.
  * XeLaTeX output, and PDF output via XeLaTeX, require texlive-xetex.
  * LuaTeX output, and PDF output via LuaTeX, require texlive-luatex.
  * ConTeXt output, and PDF output via ConTeXt, require context.
  * PDF output via wkhtmltopdf requires wkhtmltopdf.
  * Roff man and roff ms output, and PDF output via roff ms,
    require groff.
  * MathJax-rendered equations require libjs-mathjax.
  * KaTeX-rendered equations require node-katex.
  * option --csl may use styles in citation-style-language-styles.

=== debian/rules ===
#!/usr/bin/make -f

# resolve DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

# TODO: simplify rules when haskell-devscripts supports DEB_SRCDIR
#DEB_SRCDIR = pandoc-cli

DEB_CABAL_FILE = pandoc-cli/pandoc-cli.cabal
DEB_ENABLE_TESTS = yes
DEB_CABAL_PACKAGE = pandoc-cli

include /usr/share/cdbs/1/rules/debhelper.mk

# use forked Haskell build helper script to support DEB_CABAL_FILE
-include debian/hlibrary.mk

pkg = $(DEB_SOURCE_PACKAGE)

ABI = $(shell dpkg-query --showformat='$${source:Version}' --show libghc-pandoc-types-dev)
LIB = $(firstword $(subst +, ,$(DEB_VERSION_UPSTREAM)))

# Needed (always/often/seldom) at runtime
#  texlive-* needed for PDF output
#  librsvg2-bin (rsvg-convert) needed for SVG in PDF output
#  groff needed for groff man and groff ms output
# TODO: suggest slide show Javascript libraries when in Debian
CDBS_SUGGESTS_$(pkg) = texlive-latex-recommended, texlive-xetex, texlive-luatex
CDBS_SUGGESTS_$(pkg) +=, pandoc-citeproc, texlive-latex-extra, context
CDBS_SUGGESTS_$(pkg) +=, wkhtmltopdf, librsvg2-bin, groff, ghc, nodejs
CDBS_SUGGESTS_$(pkg) +=, php, perl, python, ruby, r-base-core
CDBS_SUGGESTS_$(pkg) +=, libjs-mathjax, libjs-katex
CDBS_SUGGESTS_$(pkg) +=, citation-style-language-styles

# Fix exception thrown building documentation:
# haddock: internal error: <stdout>: commitBuffer: invalid argument (invalid character)
export LANG=C.UTF-8

# Omit Lua scripting engine on unsupported architectures
ifneq (,$(filter $(DEB_BUILD_ARCH),ppc64 ppc64el))
DEB_SETUP_GHC_CONFIGURE_ARGS += --flags=-lua
else
DEB_SETUP_GHC_CONFIGURE_ARGS += --flags=+lua
endif

# Use threaded RTS only when supported
DEB_SETUP_GHC_CONFIGURE_ARGS += $(if $(wildcard /usr/lib/ghc-$(GHC_VERSION)/libHSrts_thr.a),,--flags=-threaded)

# Disable timer to help build on slow arches like hppa
DEB_SETUP_GHC_CONFIGURE_ARGS += --ghc-options="+RTS -V0 -RTS"

# Reduce compile-time memory utilization on low-memory architectures
ifneq (,$(filter $(DEB_BUILD_ARCH),armel armhf hppa mips mipsel))
DEB_SETUP_GHC_CONFIGURE_ARGS += --ghc-options="-optc--param -optcggc-min-expand=10 -O0"
endif

ifneq (,$(filter $(DEB_HOST_ARCH_CPU), i386))
DEB_SETUP_GHC_CONFIGURE_ARGS += --ghc-options="-O0"
endif

DEB_SETUP_GHC_CONFIGURE_ARGS += $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),,-ftests)

DEB_INSTALL_DOCS_ALL += README.md

build/$(pkg):: build-ghc-stamp

post-install/$(pkg)::
	debian/tmp-inst-*/usr/bin/pandoc --bash-completion \
		> debian/pandoc.bash-completion
binary-install/$(pkg)::
	dh_bash-completion
clean::
	rm -f debian/pandoc.bash-completion

# populate project at root where haskell-devscripts can use it
SRC_DATA = $(filter-out COPYING.md,\
 $(notdir $(wildcard pandoc-cli/*)))
pre-build::
	rm -rf $(SRC_DATA)
	cp --archive --target-directory=. $(addprefix pandoc-cli/,$(SRC_DATA))
clean::
	rm -rf $(SRC_DATA)

DEB_DH_GENCONTROL_ARGS_$(pkg) = -- \
 -V"pandoc:Abi=$(ABI)" \
 -V"pandoc:Lib=$(LIB)"

# generate man page only when built with Lua supprt
ifeq (,$(filter $(DEB_BUILD_ARCH),ppc64 ppc64el))
DEB_INSTALL_MANPAGES_$(pkg) = man/pandoc.1
build/$(pkg):: man/pandoc.1
man/pandoc.1: MANUAL.txt man/pandoc.1.before man/pandoc.1.after
	dist-ghc/build/pandoc/pandoc $< -f markdown -t man -s \
		--lua-filter man/manfilter.lua \
		--include-before-body man/pandoc.1.before \
		--include-after-body man/pandoc.1.after \
		--metadata author="" \
		--variable footer="pandoc $(LIB)" \
		-o $@
clean::
	rm -f man/pandoc.1
endif

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
repacksuffix=+ds,\
dversionmangle=auto \
https://github.com/jgm/pandoc/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@

## pandoc 3.1.11.1%2Bds

=== debian/control ===
--- 
+++ 
@@ -16,18 +16,18 @@
  ghc-prof,
  happy,
  haskell-devscripts,
- libghc-hslua-cli-dev (<< 1.5) [!ppc64 !ppc64el],
- libghc-hslua-cli-dev (>= 1.4.1) [!ppc64 !ppc64el],
- libghc-hslua-cli-prof [!ppc64 !ppc64el],
- libghc-pandoc-dev (>= 3.1.3),
- libghc-pandoc-lua-engine-dev (<< 0.3) [!ppc64 !ppc64el],
- libghc-pandoc-lua-engine-dev (>= 0.2) [!ppc64 !ppc64el],
- libghc-pandoc-lua-engine-prof [!ppc64 !ppc64el],
+ libghc-hslua-cli-dev (<< 1.5),
+ libghc-hslua-cli-dev (>= 1.4.1),
+ libghc-hslua-cli-prof,
+ libghc-pandoc-dev (>= 3.1.11.1),
+ libghc-pandoc-lua-engine-dev (<< 0.3),
+ libghc-pandoc-lua-engine-dev (>= 0.2),
+ libghc-pandoc-lua-engine-prof,
  libghc-pandoc-prof,
- libghc-temporary-dev (<< 1.4) [!ppc64 !ppc64el],
- libghc-temporary-prof [!ppc64 !ppc64el],
+ libghc-temporary-dev (<< 1.4),
+ libghc-temporary-prof,
  pandoc-data,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://pandoc.org/
 Vcs-Git: https://salsa.debian.org/haskell-team/pandoc.git
 Vcs-Browser: https://salsa.debian.org/haskell-team/pandoc

=== debian/rules ===
--- 
+++ 
@@ -36,13 +36,6 @@
 # haddock: internal error: <stdout>: commitBuffer: invalid argument (invalid character)
 export LANG=C.UTF-8
 
-# Omit Lua scripting engine on unsupported architectures
-ifneq (,$(filter $(DEB_BUILD_ARCH),ppc64 ppc64el))
-DEB_SETUP_GHC_CONFIGURE_ARGS += --flags=-lua
-else
-DEB_SETUP_GHC_CONFIGURE_ARGS += --flags=+lua
-endif
-
 # Use threaded RTS only when supported
 DEB_SETUP_GHC_CONFIGURE_ARGS += $(if $(wildcard /usr/lib/ghc-$(GHC_VERSION)/libHSrts_thr.a),,--flags=-threaded)
 
@@ -52,6 +45,12 @@
 # Reduce compile-time memory utilization on low-memory architectures
 ifneq (,$(filter $(DEB_BUILD_ARCH),armel armhf hppa mips mipsel))
 DEB_SETUP_GHC_CONFIGURE_ARGS += --ghc-options="-optc--param -optcggc-min-expand=10 -O0"
+endif
+
+# avoid "relocation R_LARCH_B26 overflow" during static linking
+# (see bug#1071205)
+ifneq (,$(filter $(DEB_BUILD_ARCH),loong64))
+DEB_SETUP_GHC_CONFIGURE_ARGS += --ghc-options="-optc-mcmodel=medium"
 endif
 
 ifneq (,$(filter $(DEB_HOST_ARCH_CPU), i386))
@@ -85,11 +84,10 @@
  -V"pandoc:Abi=$(ABI)" \
  -V"pandoc:Lib=$(LIB)"
 
-# generate man page only when built with Lua supprt
-ifeq (,$(filter $(DEB_BUILD_ARCH),ppc64 ppc64el))
+# generate man page
 DEB_INSTALL_MANPAGES_$(pkg) = man/pandoc.1
 build/$(pkg):: man/pandoc.1
-man/pandoc.1: MANUAL.txt man/pandoc.1.before man/pandoc.1.after
+man/pandoc.1: MANUAL.txt
 	dist-ghc/build/pandoc/pandoc $< -f markdown -t man -s \
 		--lua-filter man/manfilter.lua \
 		--include-before-body man/pandoc.1.before \
@@ -99,4 +97,3 @@
 		-o $@
 clean::
 	rm -f man/pandoc.1
-endif
